## rhvoice 1.8.0+dfsg

=== CMakeLists.txt ===
# Copyright (C) 2010, 2011, 2012, 2013, 2014, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.


cmake_minimum_required(VERSION 3.9)
project("RHVoice")

set(customCMakeModulesDir "${CMAKE_SOURCE_DIR}/cmake")
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${customCMakeModulesDir}" "${customCMakeModulesDir}/thirdparty/sanitizers/cmake")

include(FindPkgConfig)
include(GNUInstallDirs)
include(CPackComponent)
include(Hardening)
include(VersionFromGit)
find_package(Sanitizers)
getVersionFromGit("RHVOICE" "1.2.2")

if(${CMAKE_VERSION} VERSION_GREATER "3.12")
	set(CMAKE_CXX_STANDARD 20)
else()
	set(CMAKE_CXX_STANDARD 17)
endif()


set(CMAKE_C_STANDARD 11)


macro(pass_through_cpack_vars)
	get_cmake_property(cpackVarsToPassthrough VARIABLES)
	foreach(varName ${cpackVarsToPassthrough})
		if(varName MATCHES "^CPACK_")
			set("${varName}" "${${varName}}" PARENT_SCOPE)
		endif()
	endforeach()
endmacro()

if(CMAKE_INSTALL_PREFIX EQUAL "/usr")
	set(CMAKE_INSTALL_SYSCONFDIR "/etc")
endif()


set("dev" OFF CACHE BOOL "The build will only be used for development: no global installation, run from the source directory, compile helper utilities")
set("WITH_CLI11" OFF CACHE BOOL "Use CLI11 instead of bundled tclap")
set("ENABLE_MAGE" ON CACHE BOOL "Build with MAGE")
set("ENABLE_SONIC" OFF CACHE BOOL "Build with libsonic.")
set("WITH_DATA" ON CACHE BOOL "Build packages with data. Long to compress. When debugging RHVoice itself it makes sense to disable it.")
#set("spd_version" validate_spd_version CACHE ??? "Speech dispatcher version")
set("release" ON CACHE BOOL "Whether we are building a release")
set("enable_xp_compat" ON CACHE BOOL "Target Windows XP")
set("msi_repo" "" CACHE PATH "Where the msi packages are kept for reuse")
set("servicedir" "${CMAKE_INSTALL_FULL_DATADIR}/dbus-1/services" CACHE PATH ".service file installation directory")

set("data_dir" "${CMAKE_INSTALL_FULL_DATADIR}/RHVoice")
set("languages_dir" "${data_dir}/languages")
set("voices_dir" "${data_dir}/voices")

set("config_dir" "${CMAKE_INSTALL_FULL_SYSCONFDIR}/RHVoice")
set("common_doc_dir" "${CMAKE_INSTALL_FULL_DATAROOTDIR}/doc" CACHE PATH "Documentation directory path")

set(SubpackagesDir "${CMAKE_CURRENT_SOURCE_DIR}/src")
set("licenses_dir" "${CMAKE_CURRENT_SOURCE_DIR}/licenses")
set("voice_licenses_dir" "${licenses_dir}/voices")

# Working around a bug with CPACK_COMPONENTS_ALL not being properly populated by populating manually
set(CPACK_COMPONENTS_ALL "")

add_subdirectory("${SubpackagesDir}")
add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/config")
if(WITH_DATA)
	add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/data")
endif()

set(CPACK_PACKAGE_CHECKSUM "SHA512")
set(CPACK_GENERATOR "" CACHE STRING "Set generator for CPack")
set_property(CACHE CPACK_GENERATOR PROPERTY STRINGS "IFW;NSIS;NSIS64;NuGet;WIX;STGZ;7Z;TBZ2;TGZ;TXZ;TZ;TZST;ZIP;DEB;RPM;PackageMaker;CygwinBinary;DEB;DragNDrop;External;OSXX11;Bundle")
set(CPACK_DEBIAN_COMPRESSION_TYPE "xz")
set(CPACK_NSIS_COMPRESSOR "lzma")

option(CPACK_NSIS_COMPONENT_INSTALL "Split into multiple rpm packages" ON)
option(CPACK_RPM_COMPONENT_INSTALL "Split into multiple rpm packages" ON)
option(CPACK_DEB_COMPONENT_INSTALL "Split into multiple deb packages" ON)
set(CPACK_DEBIAN_ENABLE_COMPONENT_DEPENDS ON)


set(CPACK_PACKAGE_VENDOR "Olga Yakovleva")
set(CPACK_PACKAGE_CONTACT "https://github.com/RHVoice/RHVoice")
set(CPACK_PACKAGE_HOMEPAGE_URL "https://github.com/RHVoice/RHVoice")
set(CPACK_NSIS_URL_INFO_ABOUT "${CPACK_PACKAGE_HOMEPAGE_URL}")
#set(CPACK_NSIS_MUI_FINISHPAGE_RUN "echo \'Проверка связи!\" | RHVoice-test > %CSIDL_DEFAULT_DESKTOP%/RHVoice_test.wav")

if(ENABLE_MAGE)
	set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/licenses/gpl-3.0.txt")
else()
	set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/licenses/lgpl-2.1.txt")
endif()

set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.md")

set(CPACK_NSIS_DISPLAY_NAME "RHVoice")
set(CPACK_DEBIAN_PACKAGE_NAME "RHVoice")
set(CPACK_PACKAGE_VERSION_MAJOR "${RHVOICE_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${RHVOICE_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${RHVOICE_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION_TWEAK "${RHVOICE_VERSION_TWEAK}")

set(CPACK_COMPONENTS_GROUPING "IGNORE")

set(CPACK_MONOLITHIC_INSTALL OFF)
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CPACK_RESOURCE_FILE_README}")

include(CPack)

=== SConstruct ===
# Copyright (C) 2010, 2011, 2012, 2013, 2014, 2018, 2020, 2022  Olga Yakovleva <olga@rhvoice.org>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

import sys
import os
import os.path
import subprocess
import platform
import datetime
import re
if sys.platform=="win32":
    if sys.version_info[0]>=3:
        import winreg
    else:
        import _winreg as winreg

boost_includedir=Dir("#external").Dir("libs").Dir("boost").Dir("include")

def get_version(is_release):
    next_version="1.8.0"
    return next_version

def passthru(env, cmd, unique=False):
    return cmd.rstrip()

def CheckPKGConfig(context):
    context.Message("Checking for pkg-config... ")
    result=context.TryAction("pkg-config --version")[0]
    context.Result(result)
    return result

def CheckPKG(context,name):
    context.Message("Checking for {}... ".format(name))
    result=context.TryAction("pkg-config --exists '{}'".format(name))[0]
    context.Result(result)
    return result

def CheckMSVC(context):
    context.Message("Checking for Visual C++ ... ")
    result=0
    version=context.env.get("MSVC_VERSION",None)
    if version is not None:
        result=1
    context.Result(result)
    return result

def CheckXPCompat(context):
    context.Message("Checking for Windows XP compatibility ... ")
    result=0
    if context.env.get("xp_compat_enabled",False):
        result=1
    context.Result(result)
    return result

def CheckNSIS(context):
    result=0
    context.Message("Checking for NSIS")
    if "NSISDIR" in os.environ:
        context.env["makensis"]=File(os.path.join(os.environ["NSISDIR"],"makensis.exe"))
        result=1
    else:
        key_name=r"SOFTWARE\NSIS"
        try:
            with winreg.OpenKey(winreg.HKEY_LOCAL_MACHINE,key_name,0,winreg.KEY_READ|winreg.KEY_WOW64_32KEY) as key:
                context.env["makensis"]=File(os.path.join(winreg.QueryValueEx(key,None)[0],"makensis.exe"))
                result=1
        except WindowsError:
            pass
    context.Result(result)
    return result

def CheckWiX(context):
    result=0
    context.Message("Checking for WiX toolset")
    if "WIXTOOLPATH" in os.environ or "WIX" in os.environ:
        if "WIXTOOLPATH"in os.environ:
            context.env["WIX"]=os.environ["WIXTOOLPATH"]
        else:
            context.env["WIX"]=os.path.join(os.environ["WIX"],"bin")
        result=1
    context.Result(result)
    return result

def get_spd_module_dir():
    env = Environment()
    try:
        return env.ParseConfig("pkg-config speech-dispatcher --variable=modulebindir", passthru)
    except:
        return False

def validate_spd_version(key,val,env):
    m=re.match(r"^\d+\.\d+",val)
    if m is None:
        raise Exception("Invalid value of spd_version: {}".format(val))

def CheckSpdVersion(ctx):
    ctx.Message("Checking Speech Dispatcher version ... ")
    ver=ctx.env.get("spd_version",None)
    if ver is not None:
        ctx.Result(ver)
        return ver
    res, ver=ctx.TryAction("pkg-config --modversion speech-dispatcher > $TARGET")
    ver=ver.strip()
    if not res:
        src='#include <stdio.h>\n#include <speech-dispatcher/libspeechd_version.h>\nint main() {\nint major=LIBSPEECHD_MAJOR_VERSION;\nint minor=LIBSPEECHD_MINOR_VERSION;\nprintf("%d.%d",major,minor);\nreturn 0;}'
        res,ver=ctx.TryRun(src,".c")
    if not res:
        ctx.Result(res)
        return res
    ctx.env["spd_version"]=ver
    ctx.Result(ver)
    return ver

def convert_flags(value):
    return value.split()

def convert_path(value):
    return value.split(";" if sys.platform=="win32" else ":")

def setup():
    if sys.platform=="win32":
        SetOption("warn","no-visual-c-missing")
    global BUILDDIR,var_cache
    system=platform.system().lower()
    BUILDDIR=os.path.join("build",system)
    var_cache=os.path.join(BUILDDIR,"user.conf")
    Execute(Mkdir(BUILDDIR))
    SConsignFile(os.path.join(BUILDDIR,"scons"))

def create_languages_user_var():
    langs_dir=Dir("#data").Dir("languages")
    names=[name for name in sorted(os.listdir(langs_dir.path)) if os.path.isdir(langs_dir.Entry(name).path)]
    langs=[name.lower() for name in names]
    name_map=dict(zip(names,langs))
    def_langs=langs
    if sys.platform!="win32":
        def_langs=[lang for lang in langs if lang not in["georgian"]]
        print("Georgian language is skipped because of non-free license")
    help="Which languages to install"
    return ListVariable("languages",help,def_langs,langs,name_map)

def create_audio_libs_user_var():
    libs=["pulse","libao","portaudio"]
    help="Which audio libraries to use if they are available"
    return ListVariable("audio_libs",help,libs,libs)

def create_user_vars():
    args={"DESTDIR":""}
    args.update(ARGUMENTS)
    vars=Variables(var_cache,args)
    vars.Add(BoolVariable("dev","The build will only be used for development: no global installation, run from the source directory, compile helper utilities",False))
    vars.Add(create_languages_user_var())
    vars.Add(BoolVariable("enable_mage","Build with MAGE",True))
    vars.Add(BoolVariable("enable_sonic","Build with Sonic",False))
    vars.Add(BoolVariable("enable_pkg","Enable package directory code",False))
    vars.Add(create_audio_libs_user_var())
    vars.Add(BoolVariable("release","Whether we are building a release",True))
    if sys.platform=="win32":
        vars.Add(BoolVariable("sapi_dev_core", "Use the development version of the core in SAPI5 voice installers", False))
        vars.Add(BoolVariable("enable_x64","Additionally build 64-bit versions of all the libraries",True))
        vars.Add(BoolVariable("enable_xp_compat","Target Windows XP",False))
    else:
        vars.Add(PathVariable("spd_module_dir", "Speech dispatcher module directory", get_spd_module_dir(),  PathVariable.PathAccept))
        vars.Add("spd_version","Speech dispatcher version",validator=validate_spd_version)
        vars.Add("prefix","Installation prefix","/usr/local")
        vars.Add("bindir","Program installation directory","$prefix/bin")
        vars.Add("libdir","Library installation directory","$prefix/lib")
        vars.Add("includedir","Header installation directory","$prefix/include")
        vars.Add("datadir","Data installation directory","$prefix/share")
        vars.Add("sysconfdir","A directory for configuration files","$prefix/etc")
        vars.Add("servicedir",".service file installation directory","$datadir/dbus-1/services")
        vars.Add("DESTDIR","Support for staged installation","")
        vars.Add(BoolVariable("enable_shared","Build a shared library",True))
    if sys.platform=="win32":
        suffixes=["32","64"]
    else:
        suffixes=[""]
    for suffix in suffixes:
        vars.Add("CPPPATH"+suffix,"List of directories where to search for headers",[],converter=convert_path)
        vars.Add("LIBPATH"+suffix,"List of directories where to search for libraries",[],converter=convert_path)
    vars.Add("CPPFLAGS","C/C++ preprocessor flags",[],converter=convert_flags)
    vars.Add("CCFLAGS","C/C++ compiler flags",["/O2","/GL","/Gw"] if sys.platform=="win32" else ["-O2"],converter=convert_flags)
    vars.Add("CFLAGS","C compiler flags",[],converter=convert_flags)
    vars.Add("CXXFLAGS","C++ compiler flags",[],converter=convert_flags)
    vars.Add("LINKFLAGS","Linker flags",["/LTCG","/OPT:REF","/OPT:ICF"] if sys.platform=="win32" else [],converter=convert_flags)
    return vars

def create_base_env(user_vars):
    env_args={"variables":user_vars}
    if sys.platform=="win32":
        env_args["tools"]=["newlines", "msgfmt"]
    else:
        env_args["tools"]=["default","installer"]
    env_args["tools"].extend(["textfile","library"])
    env_args["LIBS"]=[]
    env_args["package_name"]="RHVoice"
    env_args["CPPDEFINES"]=[("RHVOICE","1")]
    env=Environment(**env_args)
    if env["dev"]:
        env["prefix"]=os.path.abspath("local")
        env["RPATH"]=env.Dir("$libdir").abspath
    env["package_version"]=get_version(env["release"])
    env.Append(CPPDEFINES=("PACKAGE",env.subst(r'\"$package_name\"')))
    if env["PLATFORM"]=="win32":
        env.Append(CPPDEFINES=("WIN32",1))
        env.Append(CPPDEFINES=("UNICODE",1))
        env.Append(CPPDEFINES=("NOMINMAX",1))
    env["libcore"]="RHVoice_core"
    env["libaudio"]="RHVoice_audio"
    return env

def display_help(env,vars):
    Help("Type 'scons' to build the package.\n")
    if sys.platform!="win32":
        Help("Then type 'scons install' to install it.\n")
        Help("Type 'scons --clean install' to uninstall the software.\n")
    Help("You may use the following configuration variables:\n")
    Help(vars.GenerateHelpText(env))

def clone_base_env(base_env,user_vars,arch=None):
    args={}
    if sys.platform=="win32":
        if arch is not None:
            args["TARGET_ARCH"]=arch
        args["tools"]=["msvc","mslink","mslib"]
    env=base_env.Clone(**args)
    user_vars.Update(env)
    if env["PLATFORM"]=="win32":
        env.AppendUnique(CCFLAGS=["/nologo","/MT"])
        env.AppendUnique(LINKFLAGS=["/nologo"])
        env.AppendUnique(CXXFLAGS=["/EHsc"])
        if env["enable_xp_compat"]:
            env.Tool("xp_compat")
    if "gcc" in env["TOOLS"]:
        env.MergeFlags("-pthread")
        env.AppendUnique(CXXFLAGS=["-std=c++11"])
        env.AppendUnique(CFLAGS=["-std=c11"])
        if 'SOURCE_DATE_EPOCH' in os.environ:
            env['ENV']['SOURCE_DATE_EPOCH'] = os.environ['SOURCE_DATE_EPOCH']
    if sys.platform=="win32":
        bits="64" if arch.endswith("64") else "32"
        env["BUILDDIR"]=os.path.join(BUILDDIR,arch)
        env["CPPPATH"]=env["CPPPATH"+bits]
        env["LIBPATH"]=env["LIBPATH"+bits]
    else:
        env["BUILDDIR"]=BUILDDIR
    third_party_dir=os.path.join("src","third-party")
    for path in Glob(os.path.join(third_party_dir,"*"),strings=True):
        if os.path.isdir(path):
            env.Prepend(CPPPATH=("#"+path))
    env.Prepend(CPPPATH=boost_includedir)
    env.Prepend(CPPPATH=(os.path.join("#"+env["BUILDDIR"],"include"),".",os.path.join("#src","include")))
    return env

def configure(env):
    tests={"CheckPKGConfig":CheckPKGConfig,"CheckPKG":CheckPKG,"CheckSpdVersion":CheckSpdVersion}
    if env["PLATFORM"]=="win32":
        tests["CheckMSVC"]=CheckMSVC
        tests["CheckXPCompat"]=CheckXPCompat
    conf=env.Configure(conf_dir=os.path.join(env["BUILDDIR"],"configure_tests"),
                       log_file=os.path.join(env["BUILDDIR"],"configure.log"),
                       config_h=os.path.join(env["BUILDDIR"],"include","configure.h"),
                       custom_tests=tests)
    if env["PLATFORM"]=="win32":
        if not conf.CheckMSVC():
            print("Error: Visual C++ is not installed")
            exit(1)
        print("Visual C++ version is {}".format(env["MSVC_VERSION"]))
        if env["enable_xp_compat"] and not conf.CheckXPCompat():
            print("Error: Windows XP compatibility cannot be enabled")
            exit(1)
    if not conf.CheckCC():
        print("The C compiler is not working")
        exit(1)
    if not conf.CheckCXX():
        print("The C++ compiler is not working")
        exit(1)
# has_sox=conf.CheckLibWithHeader("sox","sox.h","C",call='sox_init();',autoadd=0)
# if not has_sox:
#     print("Error: cannot link with libsox")
#     exit(1)
# env.PrependUnique(LIBS="sox")
    has_giomm=False

=== data/CMakeLists.txt ===
# Copyright (C) 2010, 2011, 2012, 2013, 2014, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
cpack_add_component_group("data")


set("ISO639_1_NAME2CODE_Russian" "ru")
set("ISO639_1_NAME2CODE_English" "en")
set("ISO639_1_NAME2CODE_Ukrainian" "uk")
set("ISO639_1_NAME2CODE_Brazilian" "br")
set("ISO639_1_NAME2CODE_Portuguese" "pt")
set("ISO639_1_NAME2CODE_Brazilian-Portuguese" "${ISO639_1_NAME2CODE_Portuguese}-BR")

set("ISO639_1_NAME2CODE_Esperanto" "eo")
set("ISO639_1_NAME2CODE_Georgian" "ka")
set("ISO639_1_NAME2CODE_Kyrgyz" "ky")
set("ISO639_1_NAME2CODE_Macedonian" "mk")
set("ISO639_1_NAME2CODE_Albanian" "sq")
set("ISO639_1_NAME2CODE_Tatar" "tt")

function(createLangCodeToNameMapping)
	get_cmake_property(varsHere VARIABLES)
	foreach(varName ${varsHere})
		if(varName MATCHES "^ISO639_1_NAME2CODE_(.+)$")
			set("ISO639_1_CODE2NAME_${${varName}}" "${CMAKE_MATCH_1}" PARENT_SCOPE)
		endif()
	endforeach()
endfunction()
createLangCodeToNameMapping()

set("VOICE_talgat_LICENSE" "Proprietary, non-commercial") # Tatar
set("VOICE_natia_LICENSE" "Proprietary, personal use only") # Georgian
set("VOICE_Leticia-F123_LICENSE" "by-sa-4.0") # Brazilian Portuguese

set("VOICE_aleksandr_LANG" "ru")
set("VOICE_aleksandr-hq_LANG" "ru")
set("VOICE_anna_LANG" "ru")
set("VOICE_vitaliy_LANG" "ru")
set("VOICE_yuriy_LANG" "ru")
set("VOICE_arina_LANG" "ru")
set("VOICE_artemiy_LANG" "ru")
set("VOICE_evgeniy-rus_LANG" "ru")
set("VOICE_elena_LANG" "ru")
set("VOICE_irina_LANG" "ru")
set("VOICE_pavel_LANG" "ru")
set("VOICE_victoria_LANG" "ru")
set("VOICE_tatiana_LANG" "ru")
set("VOICE_mikhail_LANG" "ru")

set("VOICE_evgeniy-eng_LANG" "en")
set("VOICE_lyubov_LANG" "en")
set("VOICE_alan_LANG" "en")
set("VOICE_bdl_LANG" "en")
set("VOICE_clb_LANG" "en")
set("VOICE_slt_LANG" "en")

set("VOICE_volodymyr_LANG" "uk")
set("VOICE_marianna_LANG" "uk")
set("VOICE_anatol_LANG" "uk")
set("VOICE_natalia_LANG" "uk")

set("VOICE_Leticia-F123_LANG" "${ISO639_1_NAME2CODE_Brazilian-Portuguese}")

set("VOICE_spomenka_LANG" "eo")

set("VOICE_natia_LANG" "ka")

set("VOICE_azamat_LANG" "ky")
set("VOICE_nazgul_LANG" "ky")
set("VOICE_kiko_LANG" "mk")
set("VOICE_hana_LANG" "sq")

set("VOICE_talgat_LANG" "tt")

cpack_add_component_group("data"
	DISPLAY_NAME "Data files"
	DESCRIPTION "Various data required for synthesis"
	EXPANDED
)

add_subdirectory("languages")
add_subdirectory("voices")
pass_through_cpack_vars()

=== src/CMakeLists.txt ===
pkg_check_modules(DBUS dbus)
pkg_check_modules(LIBGIOMM giomm-2.4)
pkg_check_modules(SPEECHD speech-dispatcher)

set(BUILD_CLIENT "${DBUS_FOUND}" CACHE BOOL "Build standalone RHVoice-client application")
set(BUILD_UTILS ON CACHE BOOL "Build some useful utils")
set(BUILD_TESTS ON CACHE BOOL "Build test applications")
set(BUILD_SERVICE "${LIBGIOMM_FOUND}" CACHE BOOL "Build RHVoice server application")
set(BUILD_SPEECHDISPATCHER_MODULE "${SPEECHD_FOUND}" CACHE BOOL "Build SpeechDispatcher module")

set(INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/include")
configure_file("${INCLUDE_DIR}/core/config.h.in" "${INCLUDE_DIR}/core/config.h")

set(UTF8_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/third-party/utf8")

cpack_add_component_group("libraries"
	DISPLAY_NAME "libraries"
	DESCRIPTION "Libraries that implement the needed functionality"
	EXPANDED
)

cpack_add_component_group("binaries"
	DISPLAY_NAME "Programs"
	DESCRIPTION "Programs to be called by users directly"
	EXPANDED
)

add_subdirectory("third-party")
set(HTS_LABELS_KIT_INCLUDES "${UTF8_INCLUDE_DIR}" "${RAPIDXML_INCLUDE_DIR}")

add_subdirectory("core")
add_subdirectory("audio")
add_subdirectory("lib")

if (BUILD_CLIENT)
	add_subdirectory("bin")
endif(BUILD_CLIENT)

if (BUILD_UTILS)
	add_subdirectory("utils")
endif(BUILD_UTILS)

if (BUILD_TESTS)
	add_subdirectory("test")
endif(BUILD_TESTS)

IF (WIN32)
	#add_subdirectory("sapi")
	#add_subdirectory("nvda-addon")
	#add_subdirectory("wininst")
endif()

if(BUILD_SERVICE)
	add_subdirectory("service")
endif(BUILD_SERVICE)

if(BUILD_SPEECHDISPATCHER_MODULE)
	add_subdirectory("sd_module")
endif(BUILD_SPEECHDISPATCHER_MODULE)

pass_through_cpack_vars()

=== data/voices/CMakeLists.txt ===
set("CPACK_DEBIAN_VOICES_PACKAGE_NAME" "rhvoice-voices" PARENT_SCOPE)

macro(voiceInDir voiceName voiceDir)
	set(lang_var_name "VOICE_${voiceName}_LANG")
	set(voice_license_name "VOICE_${voiceName}_LICENSE")

	if(${lang_var_name})
		set(langCode "${${lang_var_name}}")
	else()
		message(FATAL_ERROR "Please set ${lang_var_name} to the code of the lang of the voice ${voiceName} from https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes")
	endif()

	set(langNameVarName "ISO639_1_CODE2NAME_${langCode}")
	set(langName "${${langNameVarName}}")

	if(${voice_license_name})
		set(license "${${voice_license_name}}")
		set(licenseFileCandidate "${licenses_dir}/${license}.txt")
	else()
		set(license "lgpl-2.1")
		set(licenseFileCandidate "${CMAKE_SOURCE_DIR}/LICENSE.md")
	endif()

	set(languagePackageName "RHVoice-language-${langCode}")
	string(REPLACE "-" "_" languagePackageFilteredName "${languagePackageName}")

	set(voicesGroupName "RHVoice-voices-${langCode}")
	string(REPLACE "-" "_" voicesGroupFilteredName "${voicesGroupName}")
	string(TOUPPER "${voicesGroupFilteredName}" voicesGroupFilteredNameUpper)
	if(NOT DEFINED "CPACK_COMPONENT_${voicesGroupFilteredNameUpper}_GROUP")
		cpack_add_component_group("${voicesGroupFilteredName}"
			DISPLAY_NAME "${langName}"
			DESCRIPTION "Voices for ${langName} (${langCode}) language for RHVoice"
			PARENT_GROUP "voices"
			EXPANDED
		)
	endif()

	set(voicePackageName "RHVoice-voice-${langCode}-${voiceName}")
	string(REPLACE "-" "_" voicePackageFilteredName "${voicePackageName}")
	file(GLOB_RECURSE SRCFILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${voiceDir}/*")
	add_custom_target(
		"${voicePackageFilteredName}"
		SOURCES "${SRCFILES}"
	)

	string(TOUPPER "${voicePackageFilteredName}" voicePackageFilteredNameUpper)

	cpack_add_component("${voicePackageFilteredName}" GROUP "${voicesGroupFilteredName}" DISPLAY_NAME "${voiceName}"
		DESCRIPTION "${voiceName} voice for ${langName} (${langCode}) language for RHVoice licensed under `${license}` license."
		DEPENDS "${languagePackageFilteredName}"
	)
	list(APPEND CPACK_COMPONENTS_ALL "${voicePackageFilteredName}")

	set("CPACK_DEBIAN_${voicePackageFilteredNameUpper}_PACKAGE_NAME" "${voicePackageName}")
	set("CPACK_RPM_${voicePackageFilteredNameUpper}_PACKAGE_NAME" "${voicePackageName}")
	set("CPACK_DEBIAN_${voicePackageFilteredNameUpper}_PACKAGE_DEPENDS" "${CPACK_DEBIAN_CORE_PACKAGE_NAME}, RHVoice-language-${langCode}" PARENT_SCOPE)
	set("CPACK_DEBIAN_${languagePackageNameUpper}_PACKAGE_SECTION" "contrib" PARENT_SCOPE)
	
	install(DIRECTORY "${voiceDir}"
		DESTINATION "${voices_dir}"
		COMPONENT "${voicePackageFilteredName}"
		PATTERN "SConscript" EXCLUDE
		PATTERN "CMakeLists.txt" EXCLUDE
	)

	if(EXISTS "${licenseFileCandidate}")
		install(FILES "${licenseFileCandidate}"
			DESTINATION "${common_doc_dir}/${voiceName}/"
			COMPONENT "${voicePackageFilteredName}"
			RENAME "copyright"
		)
	else()
		set(licenseDirCandidate "${voice_licenses_dir}/${voiceName}")
		if(EXISTS "${licenseDirCandidate}")
			file(GLOB_RECURSE licenseFiles RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${licenseDirCandidate}/*")
			list(LENGTH "${licenseFiles}" licenseFilesLen)
			if(licenseFilesLen EQUAL "1")
				install(FILES ${licenseFiles}
					DESTINATION "${common_doc_dir}/${voiceName}/"
					COMPONENT "${voicePackageFilteredName}"
					RENAME "copyright"
				)
			else()
				install(FILES ${licenseFiles}
					DESTINATION "${common_doc_dir}/${voiceName}/"
					COMPONENT "${voicePackageFilteredName}"
				)
			endif()
		else()
			message(FATAL_ERROR "License files are missing for the voice ${voiceName}!")
		endif()
	endif()

	pass_through_cpack_vars()
endmacro()


#set("CPACK_DEBIAN_VOICES_PACKAGE_NAME" "rhvoice-voices" PARENT_SCOPE)

cpack_add_component_group("voices"
	DISPLAY_NAME "Voices"
	DESCRIPTION "Different voices"
	PARENT_GROUP "data"
	EXPANDED
)

file(GLOB voicesDirzInThisDir
	LIST_DIRECTORIES true
	"${CMAKE_CURRENT_SOURCE_DIR}/*"
)
foreach(voiceDir IN LISTS voicesDirzInThisDir)
	if(IS_DIRECTORY "${voiceDir}")
		get_filename_component(voiceName "${voiceDir}" NAME)
		if(EXISTS "${voiceDir}/CMakeLists.txt")
			add_subdirectory("${voiceDir}")
		else()
			voiceInDir("${voiceName}" "${voiceDir}" )
		endif()
	endif()
endforeach()

pass_through_cpack_vars()

=== src/bin/CMakeLists.txt ===
# -*- mode: Python; indent-tabs-mode: t; tab-width: 4 -*-
# Copyright (C) 2012, 2014, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

pkg_check_modules(DBUS REQUIRED dbus)

add_executable("RHVoice-client" "${CMAKE_CURRENT_SOURCE_DIR}/rhvoice-client.c")
target_include_directories("RHVoice-client" PRIVATE "${DBUS_INCLUDE_DIRS}")
target_link_libraries("RHVoice-client" PRIVATE "RHVoice_core" "${DBUS_LIBRARIES}")
harden("RHVoice-client")
add_sanitizers("RHVoice-client")
target_compile_definitions("RHVoice-client" PRIVATE "-DVERSION=\"${VERSION}\"")

#add_executable("RHVoice" "${CMAKE_CURRENT_SOURCE_DIR}/main.cpp")
#target_link_libraries("RHVoice" "RHVoice_core")
#target_compile_definitions(RHVoice PRIVATE "-DPACKAGE=\"RHVoice\"")
#harden("RHVoice")
#add_sanitizers("RHVoice")

cpack_add_component(client
	DISPLAY_NAME "RHVoice D-Bus service client"
	DESCRIPTION "Provides a client allowing to speak text using RHVoice DBus client. Deprecated. Use speech-dispatcher."
	GROUP "binaries"
	DEPENDS "core"
)
list(APPEND CPACK_COMPONENTS_ALL "client")

install(TARGETS "RHVoice-client"
	RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
	COMPONENT "client"
)

set("CPACK_DEBIAN_CLIENT_PACKAGE_NAME" "rhvoice-client")
set(CPACK_DEBIAN_CLIENT_PACKAGE_DEPENDS "${CPACK_DEBIAN_CORE_PACKAGE_NAME}, ${CPACK_DEBIAN_AUDIO_PACKAGE_NAME}")

pass_through_cpack_vars()

=== src/core/CMakeLists.txt ===
# -*- mode: Python; indent-tabs-mode: t; tab-width: 4 -*-
# Copyright (C) 2012, 2018, 2019  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.


file(GLOB_RECURSE SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/*.c" "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp")

# database files, included into needed places
list(REMOVE_ITEM SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/emoji_data.cpp")
list(REMOVE_ITEM SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/unidata.cpp")
list(REMOVE_ITEM SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/userdict_parser.c")

if(ENABLE_SONIC)
	set(CPACK_DEBIAN_CORE_PACKAGE_DEPENDS "${CPACK_DEBIAN_LIBSONIC_PACKAGE_NAME}")
endif()

if(ENABLE_MAGE)
	list(APPEND CPACK_DEBIAN_CORE_PACKAGE_DEPENDS "${CPACK_DEBIAN_LIBMAGE_PACKAGE_NAME}")
else()
	list(REMOVE_ITEM SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/mage_hts_engine_impl.cpp")
endif()

add_library(RHVoice_core SHARED "${SRCFILES}")
set_target_properties(RHVoice_core PROPERTIES VERSION "${RHVOICE_VERSION}" SOVERSION "${RHVOICE_VERSION_MAJOR}")
set(libs2link "libhts_engine")
target_include_directories(RHVoice_core PUBLIC "${INCLUDE_DIR}" PRIVATE "${HTS_LABELS_KIT_INCLUDES}")

set(package_name "RHVoice_core")

set(VERSION "${RHVOICE_VERSION}")

if(ENABLE_SONIC)
	list(APPEND libs2link "sonic")
endif()
if(ENABLE_MAGE)
	list(APPEND libs2link "libmage")
endif()
set(CONFIG_PATH "${config_dir}")
set(DATA_PATH "${data_dir}")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.h.in" "${CMAKE_CURRENT_SOURCE_DIR}/config.h")

target_link_libraries(RHVoice_core "${libs2link}")
harden("RHVoice_core")
add_sanitizers("RHVoice_core")

cpack_add_component(core
	DISPLAY_NAME "Synthesis core"
	DESCRIPTION "Provides a library that does speech synthesis"
	REQUIRED
	GROUP "libraries"
	DEPENDS "libhts_engine"
)
list(APPEND CPACK_COMPONENTS_ALL "core")

install(TARGETS "RHVoice_core"
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	COMPONENT "core"
)

if(ENABLE_MAGE)
	list(APPEND CPACK_COMPONENT_CORE_DEPENDS "libmage")
endif()
if(Sonic_FORCE_COMPILATION)
	list(APPEND CPACK_COMPONENT_CORE_DEPENDS "libsonic")
endif()

string(REPLACE ";" ", " CPACK_DEBIAN_CORE_PACKAGE_DEPENDS "${CPACK_DEBIAN_CORE_PACKAGE_DEPENDS}")
set("CPACK_DEBIAN_CORE_PACKAGE_NAME" "librhvoice-core")

pass_through_cpack_vars()

=== src/sd_module/CMakeLists.txt ===
# -*- mode: Python; indent-tabs-mode: t; tab-width: 4 -*-
# Copyright (C) 2012, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

pkg_check_modules(SPEECHD REQUIRED speech-dispatcher)

file(GLOB_RECURSE SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/*.c" "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp")
add_executable(sd_rhvoice "${SRCFILES}")
target_include_directories(sd_rhvoice PRIVATE "${INCLUDE_DIR}" "${HTS_LABELS_KIT_INCLUDES}" "${SPEECHD_INCLUDE_DIRS}")
target_link_libraries(sd_rhvoice "RHVoice_core" "RHVoice_audio" "${SPEECHD_LIBRARIES}" pthread)
harden(sd_rhvoice)
add_sanitizers(sd_rhvoice)

pkg_get_variable(modulebindir ${SPEECHD_MODULE_NAME} modulebindir)
if (NOT modulebindir)
	pkg_get_variable(libdir ${SPEECHD_MODULE_NAME} libdir)
	set(modulebindir "${libdir}/speech-dispatcher-modules")
endif()
set(SPEECH_DISPATCHER_MODULES_DIR "${modulebindir}" CACHE PATH "Speech Dispatcher's module directory path")


cpack_add_component(sd_module
	DISPLAY_NAME "RHVoice speech-dispatcher middleware module"
	DESCRIPTION "Provides a way to use RHVoice using speech-dispacher middleware. It is the recommended way to use RHVoice on *nix hosts."
	GROUP "binaries"
	DEPENDS "core" "audio"
)
list(APPEND CPACK_COMPONENTS_ALL "sd_module")

install(TARGETS "sd_rhvoice"
	RUNTIME DESTINATION "${SPEECH_DISPATCHER_MODULES_DIR}"
	COMPONENT "sd_module"
)

set("CPACK_DEBIAN_SD_MODULE_PACKAGE_NAME" "speech-dispatcher-rhvoice")
set(CPACK_DEBIAN_SD_MODULE_PACKAGE_DEPENDS "${CPACK_DEBIAN_CORE_PACKAGE_NAME}, speech-dispatcher")
set(CPACK_DEBIAN_SD_MODULE_PACKAGE_SUGGESTS "spd-say, python3-speechd")
pass_through_cpack_vars()

=== src/service/CMakeLists.txt ===
# -*- mode: Python; indent-tabs-mode: t -*-
# Copyright (C) 2012, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.


#pkg_check_modules(LIBGLIMM REQUIRED glibmm-2.4)
pkg_check_modules(LIBGIOMM REQUIRED giomm-2.4)

add_executable("RHVoice-service" "${CMAKE_CURRENT_SOURCE_DIR}/service.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/common.cpp")
target_include_directories("RHVoice-service" PRIVATE "${LIBGIOMM_INCLUDE_DIRS}" "${HTS_LABELS_KIT_INCLUDES}")
target_link_libraries("RHVoice-service" "RHVoice_core" "${LIBGIOMM_LIBRARIES}")
harden("RHVoice-service")
add_sanitizers("RHVoice-service")

install(TARGETS "RHVoice-service"
	RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
	COMPONENT "service"
)
set(SERVICE_FILE_NAME "com.github.OlgaYakovleva.RHVoice.service")

set(serviceInputFile "${CMAKE_CURRENT_SOURCE_DIR}/${SERVICE_FILE_NAME}.in")
set(serviceOutputFile "${CMAKE_CURRENT_BINARY_DIR}/${SERVICE_FILE_NAME}")

set(bindir "${CMAKE_INSTALL_FULL_BINDIR}")
set("servicedir" "${CMAKE_INSTALL_DATADIR}/dbus-1/services" CACHE PATH ".service file installation directory")
set("servicedir_full" "${CMAKE_INSTALL_PREFIX}/${servicedir}")
configure_file("${serviceInputFile}" "${serviceOutputFile}")
install(FILES "${serviceOutputFile}"
	DESTINATION "${servicedir}/systemd/system"
	COMPONENT "service"
)
set("CPACK_DEBIAN_SERVICE_PACKAGE_NAME" "rhvoice-systemd-service" PARENT_SCOPE)

=== src/test/CMakeLists.txt ===
# -*- mode: Python; indent-tabs-mode: t; tab-width: 4 -*-
# Copyright (C) 2012, 2014, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

add_executable("RHVoice-test" "${CMAKE_CURRENT_SOURCE_DIR}/test.cpp")
target_link_libraries("RHVoice-test" "RHVoice" "RHVoice_audio")
target_include_directories("RHVoice-test" PRIVATE "${TCLAP_INCLUDE_DIR}" "${HTS_LABELS_KIT_INCLUDES}")
harden("RHVoice-test")
add_sanitizers("RHVoice-test")

if(WITH_CLI11)
	target_compile_definitions(RHVoice-test PRIVATE WITH_CLI11)
endif(WITH_CLI11)

cpack_add_component(test
	DISPLAY_NAME "Standalone CLI application"
	DESCRIPTION "Provides a CLI application that allows you to synthesize speech using RHVoice"
	GROUP "binaries"
	DEPENDS "audio"
)
list(APPEND CPACK_COMPONENTS_ALL "test")

install(TARGETS "RHVoice-test"
	RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
	COMPONENT "test"
)
set("CPACK_DEBIAN_TEST_PACKAGE_NAME" "rhvoice-test")
set(CPACK_DEBIAN_TEST_PACKAGE_DEPENDS "${CPACK_DEBIAN_CORE_PACKAGE_NAME}, ${CPACK_DEBIAN_AUDIO_PACKAGE_NAME}")


pass_through_cpack_vars()

=== src/third-party/CMakeLists.txt ===
# -*- mode: Python; indent-tabs-mode: t; tab-width: 4; python-indent: 4 -*-
# Copyright (C) 2013  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

if(ENABLE_MAGE)
	add_subdirectory("mage")
endif()

if(ENABLE_SONIC)
	add_subdirectory("sonic")
endif()
add_subdirectory("hts_engine")

set(RAPIDXML_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/rapidxml" PARENT_SCOPE)

pkg_check_modules(TCLAP tclap)
if("${TCLAP_FOUND}" AND NOT "${TCLAP_FORCE_COMPILATION}")
	set(TCLAP_INCLUDE_DIR "${TCLAP_INCLUDEDIR}" PARENT_SCOPE)
else()
	set(TCLAP_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/tclap" PARENT_SCOPE)
endif()

pass_through_cpack_vars()

=== src/third-party/hts_engine/CMakeLists.txt ===
# -*- mode: Python; indent-tabs-mode: t; tab-width: 4; python-indent: 4 -*-
# Copyright (C) 2013  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

file(GLOB_RECURSE SRCFILES1 "${CMAKE_CURRENT_SOURCE_DIR}/HTS_*.c")

if(ENABLE_MAGE)
	file(GLOB_RECURSE SRCFILES2 "${CMAKE_CURRENT_SOURCE_DIR}/HTS106_*.c")
	set(CPACK_DEBIAN_LIBHTS_ENGINE_PACKAGE_DEPENDS "${CPACK_DEBIAN_LIBMAGE_PACKAGE_NAME}")
else()
	set(SRCFILES2 "")
endif()

add_library(libhts_engine SHARED "${SRCFILES1}" "${SRCFILES2}")
target_compile_definitions(libhts_engine PRIVATE "-DAUDIO_PLAY_NONE")

set(LIBHTS_VERSION_MAJOR 1)
set(LIBHTS_VERSION_MINOR 06)
set(LIBHTS_VERSION_PATCH 0)
set(LIBHTS_VERSION "${LIBHTS_VERSION_MAJOR}.${LIBHTS_VERSION_MINOR}-RHVoice")
set_target_properties(libhts_engine PROPERTIES VERSION "${LIBHTS_VERSION}" SOVERSION "${LIBHTS_VERSION_MAJOR}")

set(CPACK_COMPONENT_LIBHTS_ENGINE_VERSION_MAJOR "${LIBHTS_VERSION_MAJOR}")
set(CPACK_COMPONENT_LIBHTS_ENGINE_VERSION_MINOR "${LIBHTS_VERSION_MINOR}")
set(CPACK_COMPONENT_LIBHTS_ENGINE_VERSION_PATCH "${LIBHTS_VERSION_PATCH}")
set(CPACK_COMPONENT_LIBHTS_ENGINE_VERSION "${LIBHTS_VERSION}")

target_include_directories(libhts_engine PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}" "${INCLUDE_DIR}")
if(NOT MSVC)
	target_link_libraries(libhts_engine PUBLIC m)
endif()
harden(libhts_engine)
add_sanitizers(libhts_engine)
set_target_properties("libhts_engine" PROPERTIES PREFIX "")


cpack_add_component(libhts_engine
	DISPLAY_NAME "HTS engine"
	DESCRIPTION "hts_engine is software to synthesize speech waveform from HMMs trained by the HMM-based speech synthesis system (HTS). This software is released under the Modified BSD license. This component contains a modified version of HTS engine, for the modifications see the RHVoice GitHub repo."
	GROUP "third_party_libs"
)
list(APPEND CPACK_COMPONENTS_ALL "libhts_engine")

install(TARGETS "libhts_engine"
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	COMPONENT "libhts_engine"
)
set("CPACK_DEBIAN_LIBHTS_ENGINE_PACKAGE_NAME" "libhtsengine")
pass_through_cpack_vars()

=== debian/control ===
Source: rhvoice
Section: non-free/sound
Priority: optional
Maintainer: Debian TTS Team <tts-project@alioth-lists.debian.net>
Uploaders: Samuel Thibault <sthibault@debian.org>
Build-Depends: debhelper-compat (= 13),
 scons,
 libglibmm-2.4-dev,
 portaudio19-dev,
 libpulse-dev,
 libao-dev,
# libhtsengine-dev,
# TODO: libmage-dev,
 librapidxml-dev,
 libsonic-dev,
 libtclap-dev,
 libutfcpp-dev,
 libboost-dev,
 libspeechd-dev
Standards-Version: 4.6.0
Homepage: https://github.com/Olga-Yakovleva/RHVoice
Vcs-Browser: https://salsa.debian.org/tts-team/rhvoice
Vcs-Git: https://salsa.debian.org/tts-team/rhvoice.git
Rules-Requires-Root: no
XS-Autobuild: yes

Package: rhvoice
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Speech synthesizer - test tools
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains test tools

Package: speech-dispatcher-rhvoice
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, speech-dispatcher
Description: RHVoice speech synthesizer - speech dispatcher module
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains the speech dispatcher module to use RHVoice

Package: rhvoice-russian
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Russian voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Russian voice

Package: rhvoice-kyrgyz
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Kyrgyz voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Kyrgyz voice

# Note: this voice (Talgat) is really non-free by licence
Package: rhvoice-tatar
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Tatar voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Tatar voice

Package: rhvoice-brazilian-portuguese
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Brazilian Portuguese voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Brazilian Portuguese voice

Package: rhvoice-ukrainian
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Ukrainian voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Ukrainian voice

Package: rhvoice-esperanto
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Esperanto voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Esperanto voice

Package: rhvoice-english
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - English voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the English voice

Package: rhvoice-albanian
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Albanian voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Albanian voice

Package: rhvoice-macedonian
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Macedonian voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Macedonian voice

Package: rhvoice-polish
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Polish voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Polish voice

Package: librhvoice-dev
Section: non-free/libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 librhvoice5 (= ${binary:Version}),
 librhvoice-core7 (= ${binary:Version}),
 librhvoice-audio2 (= ${binary:Version}),
Description: RHVoice speech synthesizer - development files
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains the development files.

Package: librhvoice5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: RHVoice speech synthesizer - shared library
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains the shared library

Package: librhvoice-core7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, rhvoice-english | rhvoice-voice
Conflicts: librhvoice-core4
Replaces: librhvoice-core4
Description: RHVoice speech synthesizer - core shared library
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains the core shared library

Package: librhvoice-audio2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: RHVoice speech synthesizer - audio shared library
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains the audio shared library

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

SCONS=scons

%:
	dh $@

override_dh_auto_configure:
	:

override_dh_auto_build:
	$(SCONS) prefix="/usr" sysconfdir="/etc" libdir="/usr/lib/$(DEB_HOST_MULTIARCH)" \
		CPPFLAGS="$(CPPFLAGS)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		CXX="$(CXX)" \
		CXXFLAGS="$(CXXFLAGS)" \
		LINKFLAGS="$(LDFLAGS)" \
		enable_sonic=True

#		enable_pkg=True

override_dh_auto_clean:
	dh_auto_clean
	$(SCONS) -c
	rm -fr $(CURDIR)/build
	py3clean .

override_dh_auto_install:
	scons DESTDIR=$(CURDIR)/debian/tmp install
